'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transform;

var _webpackSources = require('webpack-sources');

var _bindCode = require('./bindCode');

var _bindCode2 = _interopRequireDefault(_bindCode);

var _moduleExport = require('./moduleExport');

var _moduleExport2 = _interopRequireDefault(_moduleExport);

var _provideDependencies = require('./provideDependencies');

var _provideDependencies2 = _interopRequireDefault(_provideDependencies);

var _determineShimOptions2 = require('./determineShimOptions');

var _determineShimOptions3 = _interopRequireDefault(_determineShimOptions2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transform(requestedModule, code, sourcemap, file, shimConfig) {
  var _determineShimOptions = (0, _determineShimOptions3.default)(requestedModule, shimConfig);

  var deps = _determineShimOptions.deps;
  var exported = _determineShimOptions.exported;
  var context = _determineShimOptions.context;
  var module = _determineShimOptions.module;
  var require = _determineShimOptions.require;
  var define = _determineShimOptions.define;


  var moduleDependencies = (0, _provideDependencies2.default)(deps);
  var moduleExported = typeof exported !== 'undefined' ? (0, _moduleExport2.default)(exported) : '';
  var wrapper = (0, _bindCode2.default)(context, module, module, require, define, !!moduleExported);

  var header = [moduleDependencies, wrapper.header, '\n'].join('\n');

  var footer = [';\n', moduleExported, wrapper.footer].join('\n');

  var sourceHeader = new _webpackSources.RawSource(header);
  var sourceContent = sourcemap ? new _webpackSources.SourceMapSource(code, file, sourcemap) : new _webpackSources.OriginalSource(code, file);
  var sourceFooter = new _webpackSources.RawSource(footer);

  var source = new _webpackSources.ConcatSource(sourceHeader, sourceContent, sourceFooter);

  return source.sourceAndMap();
}